VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "ScreenScroll"
   ClientHeight    =   1380
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4650
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1380
   ScaleWidth      =   4650
   StartUpPosition =   3  'Windows Default
   Begin VB.Label lblInfo 
      BorderStyle     =   1  'Fixed Single
      Caption         =   $"frmMain.frx":0ABA
      Height          =   1305
      Left            =   30
      TabIndex        =   0
      Top             =   30
      Width           =   4575
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
'Needed to fix the update of the wallpaper if you want to move it along with the windows.
'The difference is ByVal lpvParam and ByRef lpvParam.
'It is very odd that it does not work...
Private Declare Function SystemParametersInfoAlt Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByVal lpvParam As Any, ByVal fuWinIni As Long) As Long

'Wallpaper
Private Const SPI_SETDESKWALLPAPER = 20
Private Const SPIF_SENDWININICHANGE = &H2
Private Const SPIF_UPDATEINIFILE = &H1

'Get the screen size minus toolbars.
Private Const SPI_GETWORKAREA = 48

Private Sub Form_Load()
Dim sCommand As String
Dim sTemp As String
Dim bMoveWallpaper As Boolean
Dim sX As String
Dim sY As String
Dim lTheNumber As Long
    'The space is added to ease the get number if that is the only thing passed in the command line parameters.
    sCommand = " " & LCase(Trim(Command$))
    
    'sCommand = "-ve 100"
    'sCommand = "gw"
    'sCommand = "-hsw 25"
    'sCommand = "-hvw 500 100"
    'sCommand = "-hvsw 50 20"
    
    'sCommand = "his 100"
    
    bVertical = False
    bHorisontal = False
    bGather = False
    lOption = -1
    bUseExcludInclude = False
    bExclude = False
    
    If InStr(sCommand, "g") > 0 Then
        lOption = 0
        bGather = True
    End If
    If InStr(sCommand, "v") > 0 Then
        lOption = I_VERTICAL
        bVertical = True
    End If
    If InStr(sCommand, "h") > 0 Then
        lOption = I_HORISONTAL
        bHorisontal = True
    End If
    
    'Default to +
    iDirection = 1
    If InStr(sCommand, "-") > 0 Then
        iDirection = -1
    End If

    'Get the workarea, that is the screen minus toolbars.
    SystemParametersInfo SPI_GETWORKAREA, 0, WindowRect, 0
    
    If InStr(sCommand, "e") > 0 Then    'Screens
        bExclude = True
        initFileRead App.Path & "\exclude.txt"
    ElseIf InStr(sCommand, "i") > 0 Then    'Screens
        initFileRead App.Path & "\include.txt"
    End If

    
    If InStr(sCommand, "s") > 0 Then    'Screens
        'Default to 25
        'lTheNumber = lGetTheNumber(sCommand, 25)
        'lVertical = lTheNumber * WindowRect.Bottom / 100
        'lHorisontal = lTheNumber * WindowRect.Right / 100
    
        lGetTheNumbers sCommand, lVertical, lHorisontal, 25
        lVertical = lVertical * WindowRect.Bottom / 100
        lHorisontal = lHorisontal * WindowRect.Right / 100
    Else    'Pixels
        'Default to 50
        'lTheNumber = lGetTheNumber(sCommand, 50)
        'lVertical = lTheNumber
        'lHorisontal = lTheNumber
        
        lGetTheNumbers sCommand, lVertical, lHorisontal, 50
    
    End If
       
       
    If lOption > -1 Then
        Call fEnumWindows
    End If
       
    If InStr(sCommand, "w") > 0 Then
        bMoveWallpaper = True
    Else
        bMoveWallpaper = False
    End If
    If bMoveWallpaper Then
        Dim strOldWallpaperPath As String
        strOldWallpaperPath = Trim(GetString(HKEY_CURRENT_USER, "Control Panel\desktop", "Wallpaper"))
        'Debug.Print strOldWallpaperPath
        Dim lRet As Long
        If lOption = 0 Then 'Gather
            SaveString HKEY_CURRENT_USER, "Control Panel\Desktop", "WallpaperOriginX", "0"
            SaveString HKEY_CURRENT_USER, "Control Panel\Desktop", "WallpaperOriginY", "0"
            Call SystemParametersInfoAlt(SPI_SETDESKWALLPAPER, 0, strOldWallpaperPath, SPIF_UPDATEINIFILE Or SPIF_SENDWININICHANGE)
        ElseIf lOption = I_VERTICAL Then
            sY = GetString(HKEY_CURRENT_USER, "Control Panel\Desktop", "WallpaperOriginY")
            SaveString HKEY_CURRENT_USER, "Control Panel\Desktop", "WallpaperOriginY", CStr(CLng(sY) + iDirection * lVertical)
            Call SystemParametersInfoAlt(SPI_SETDESKWALLPAPER, 0, strOldWallpaperPath, SPIF_UPDATEINIFILE Or SPIF_SENDWININICHANGE)
        ElseIf lOption = I_HORISONTAL Then
            sX = GetString(HKEY_CURRENT_USER, "Control Panel\Desktop", "WallpaperOriginX")
            SaveString HKEY_CURRENT_USER, "Control Panel\Desktop", "WallpaperOriginX", CStr(CLng(sX) + iDirection * lHorisontal)
            Call SystemParametersInfoAlt(SPI_SETDESKWALLPAPER, 0, strOldWallpaperPath, SPIF_UPDATEINIFILE Or SPIF_SENDWININICHANGE)
        End If
    End If
       
    If lOption > -1 Then
        Unload Me
        Exit Sub
    End If
End Sub

'Private Function lGetTheNumber(sCommand As String, lDefault As Long) As Long
'Dim sTemp As String
'    If InStr(sCommand, " ") > 0 Then
'        sTemp = Trim(Right(sCommand, Len(sCommand) - InStrRev(sCommand, " ") + 1))
'        If IsNumeric(sTemp) Then
'            lGetTheNumber = CLng(sTemp)
'        Else
'            lGetTheNumber = lDefault
'        End If
'    End If
'End Function

Private Sub lGetTheNumbers(ByVal sCommand As String, lVertical As Long, lHorisontal As Long, lDefault As Long)
Dim sTemp As String
    lVertical = lDefault
    lHorisontal = lDefault
    If InStr(sCommand, " ") > 0 Then
        sTemp = Trim(Right(sCommand, Len(sCommand) - InStrRev(sCommand, " ") + 1))
        sCommand = " " & Trim(Left(sCommand, InStrRev(sCommand, " ")))
        If IsNumeric(sTemp) Then
            lHorisontal = CLng(sTemp)
        End If
    End If
    If InStr(sCommand, " ") > 0 Then
        sTemp = Trim(Right(sCommand, Len(sCommand) - InStrRev(sCommand, " ") + 1))
        'sCommand = Trim(Left(sCommand, InStrRev(sCommand, " ")))
        If IsNumeric(sTemp) Then
            lVertical = CLng(sTemp)
        Else
            If lHorisontal <> lDefault Then
                lVertical = lHorisontal
            End If
        End If
    End If
End Sub


Private Sub initFileRead(sFile As String)
Dim sTemp As String
Dim lFile As Long
    On Error Resume Next
    
    If Dir(sFile) <> vbNullString Then
        lFile = FreeFile
        Open sFile For Input As #lFile
        sTemp = Input(LOF(lFile), lFile) 'read the whole file at once instead of one row at the time
        Close lFile
        sTitleArray = Split(sTemp, vbCrLf) 'split the file into different lines
        bUseExcludInclude = True
        'initFileRead = True
    Else
        'The file did not exist, ignore it.
        'initFileRead = False
    End If

End Sub
