Attribute VB_Name = "modEnum"
Option Explicit
'Part of the code is copied from http://www.freevbcode.com/ShowCode.asp?ID=6339

Public Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long
'Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

'Movement of the windows.
Private Declare Function SetWindowPos Lib "user32.dll" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
'End movement of the windows.

Public Const I_HORISONTAL = 1
Public Const I_VERTICAL = 2


Public Const GW_OWNER = 4
Public Const GWL_EXSTYLE = (-20)
'Public Const WS_EX_TOOLWINDOW = &H80
'Public Const WS_EX_APPWINDOW = &H40000
Const MAX_PATH& = 260
Public HHWnd As Long

Public bVertical   As Boolean
Public bHorisontal As Boolean
Public bGather   As Boolean

Public lOption     As Long
Public lVertical   As Long
Public lHorisontal As Long
Public iDirection  As Integer
Public WindowRect  As RECT

Public sTitleArray() As String
Public bUseExcludInclude As Boolean
Public bExclude As Boolean

Public Function WhichWindowsCallBack(ByVal hwnd As Long, ByVal lParam As Long) As Long
Dim lReturn     As Long
Dim lExStyle    As Long
Dim bNoOwner    As Boolean
Dim sWindowText As String
Dim Rec         As RECT
Dim lTop        As Long
Dim lLeft       As Long

    If hwnd <> frmMain.hwnd Then
        If IsWindowVisible(hwnd) Then
            'If GetParent(hwnd) = 0 Then
                bNoOwner = (GetWindow(hwnd, GW_OWNER) = 0)
                lExStyle = GetWindowLong(hwnd, GWL_EXSTYLE)
                
                'If (((lExStyle And WS_EX_TOOLWINDOW) = 0) And bNoOwner) Or _
                '    ((lExStyle And WS_EX_APPWINDOW) And Not bNoOwner) Then
                    sWindowText = Space$(256)
                    lReturn = GetWindowText(hwnd, sWindowText, Len(sWindowText))
                    If lReturn Then
                        
                        If bUseExcludInclude Then
                            If bDoNotMoveWindow(sWindowText) Then
                                GoTo exitTheFunction
                            End If
                        End If
                        
                        sWindowText = Left$(sWindowText, lReturn)
                        GetWindowRect hwnd, Rec
                        lTop = Rec.Top
                        lLeft = Rec.Left
                        
                        'If lOption = I_VERTICAL Then 'Vertical
                        If bVertical Then
                            lTop = Rec.Top + iDirection * lVertical
                            'lLeft = Rec.Left
                        End If
                        'ElseIf lOption = I_HORISONTAL Then 'Horisontal
                        If bHorisontal Then
                            'lTop = Rec.Top
                            lLeft = Rec.Left + iDirection * lHorisontal
                        End If
                        'Else 'Gather the windows to the screen. Favor that the top left corner is in-screen.
                        'Favour gather if the user passes g with v and/or h.
                        If bGather Then
                            lLeft = Rec.Left
                            lTop = Rec.Top
                            If Rec.Bottom > WindowRect.Bottom Then 'If it is too low down, move upp
                                lTop = WindowRect.Bottom - (Rec.Bottom - Rec.Top)
                            End If
                            If Rec.Top < 0 Then 'If it is too high up, move down.
                                lTop = 0
                            End If
                            If Rec.Right > WindowRect.Right Then 'If it is too long to the right, move to the left.
                                lLeft = WindowRect.Right - (Rec.Right - Rec.Left)
                            End If
                            If Rec.Left < 0 Then 'If it is too long to the left, move to the right
                                lLeft = 0
                            End If
                        End If
                        SetWindowPos hwnd, 1, lLeft, lTop, 0, 0, &H1
                    End If
                'End If
            'End If
        End If
    End If
exitTheFunction:
    HHWnd = hwnd
    WhichWindowsCallBack = True
End Function

Public Function bDoNotMoveWindow(sTitle As String) As Boolean
Dim lIndex As Long
Dim lInStringIndex As Long
    For lIndex = 0 To UBound(sTitleArray)
        'check if the string is a match, return differnt depending on
        If sTitleArray(lIndex) <> vbNullString Then
        lInStringIndex = InStr(1, sTitle, sTitleArray(lIndex), vbTextCompare)
        If lInStringIndex > 0 Then
            If bExclude Then
                bDoNotMoveWindow = True
            Else
                bDoNotMoveWindow = False
            End If
            Exit Function
        End If
        End If
    Next lIndex
    If bExclude Then
        bDoNotMoveWindow = False
    Else
        bDoNotMoveWindow = True
    End If
End Function

Public Sub fEnumWindows()
    Call EnumWindows(AddressOf WhichWindowsCallBack, frmMain.hwnd)
End Sub

